STK	SEGMENT	STACK
	DW	128 DUP (?)
STK	ENDS

CODE	SEGMENT	PARA
	ASSUME	CS:CODE,DS:CODE,SS:STK,ES:NOTHING

;-------------------------------------------

VINT	PROC	FAR

	CMP	AX,0012H	;640x480x16
	JZ	M50HZ
	CMP	AX,005DH	;640x480x256
	JZ	M50HZ
	PUSHF			;call old vector
	CALL	CS:OLDVINT
	IRET

M50HZ:	PUSHF			;call old vector
	CALL	CS:OLDVINT
	PUSH	AX		;save registers
	PUSH	DX
	CLI			;disable interrupts
	MOV	DX,03C2H	;adjust clock and sync pol.
	MOV	AL,227
	OUT	DX,AL
	MOV	DX,3C4H		;switch to old mode
	MOV	AX,0BH
	OUT	DX,AX
	INC	DX
	IN	AL,DX		;now to new mode
	DEC	DX
	MOV	AL,0DH		;new mode control 1
	OUT	DX,AL
	INC	DX
	IN	AL,DX
	AND	AL,0F8H		;mask out clock bits
	OUT	DX,AL
	MOV	DX,03D4H
	MOV	AX,0810H	;CRTC [10H]
	OUT	DX,AX
	MOV	AX,0011H	;unlock CRTC [0..7]
	OUT	DX,AX
	MOV	AX,0012H	;CRTC [12H]
	OUT	DX,AX
	MOV	AL,13H		;CRTC [13H]
	OUT	DX,AL
	INC	DX
	IN	AL,DX
	SHL	AL,1		;line offset
	OUT	DX,AL
	DEC	DX
	MOV	AX,0015H	;CRTC [15H]
	OUT	DX,AX
	MOV	AX,2816H	;CRTC [16H]
	OUT	DX,AX
	MOV	AX,3806H	;CRTC [06H]
	OUT	DX,AX
	MOV	AX,1F07H	;CRTC [07H]
	OUT	DX,AX
	MOV	AL,1EH   	;set interlace flag
	OUT	DX,AL
	INC	DX
	IN	AL,DX
	OR	AL,4
	OUT	DX,AL
	DEC	DX
	XOR	AL,AL		;check if in double dot clock mode
	OUT	DX,AL
	INC	DX
	IN	AL,DX
	CMP	AL,160
	JA	HTX2
	MOV	DX,03C4H
	MOV	AL,1            ;divide clock by two
	OUT     DX,AL
	INC     DX
	IN	AL,DX
	OR	AL,8
	OUT	DX,AL
	MOV	DX,03D4H
	MOV	AX,6000H	;CRTC [0]
	OUT	DX,AX
	MOV	AX,4F01H	;CRTC [1]
	OUT	DX,AX
	MOV	AX,5002H	;CRTC [2]
	OUT	DX,AX
	MOV	AX,8303H	;CRTC [3]
	OUT	DX,AX
	MOV	AX,5604H	;CRTC [4]
	OUT	DX,AX
	MOV	AX,9C05H	;CRTC [5]
	OUT	DX,AX
	JMP	DONE
HTX2:   MOV	DX,03D4H
	MOV	AX,0C500H	;CRTC [0]
	OUT	DX,AX
	MOV	AX,9F01H	;CRTC [1]
	OUT	DX,AX
	MOV	AX,0A102H	;CRTC [2]
	OUT	DX,AX
	MOV	AX,8403H	;CRTC [3]
	OUT	DX,AX
	MOV	AX,0AA04H	;CTRC [4]
	OUT	DX,AX
	MOV	AX,1605H	;CRTC [5]
	OUT	DX,AX
DONE:   MOV	AX,08A11H	;CRTC [11H], relock [0..7]
	OUT	DX,AX
	STI			;enable interrupts
	POP	DX		;restore registers
	POP	AX
	IRET

VINT	ENDP

PRG_ID	DB	'TV-MODE'
OLDVINT	DD	0
PSP	DW	0

MSG1	DB	'VGA->TV-Converter V0.8 (Jul 10 1996) by Steffen Koehler',10,13,'$'
MSG2	DB	'Trident card detected, program installed',10,13,'$'
MSG3	DB	'No Trident card found, program not loaded',10,13,'$'
MSG4	DB	'Successfully removed from memory',10,13,'$'

START:

	MOV	AX,CS		;DS=CS
	MOV	DS,AX

;print out copyright msg

	MOV	AH,9
	MOV	DX,OFFSET MSG1
	INT	21H

;free environment memory

	MOV	CS:PSP,ES
	MOV	AH,49H
	MOV	ES,ES:[2CH]
	INT	21H

;get vector of current video interrupt

	MOV	AX,3510H
	INT	21H
	MOV	WORD PTR CS:OLDVINT,BX
	MOV	WORD PTR CS:OLDVINT+2,ES

;check if already loaded

	MOV	SI,OFFSET PRG_ID
	MOV	DI,SI
	MOV	CX,7
	CLD
REPNZ	CMPSB
	JNZ	INIT

;remove program from memory

	MOV	AH,9
	MOV	DX,OFFSET MSG4
	INT	21H
	MOV	DX,ES:WORD PTR OLDVINT
	MOV	DS,ES:WORD PTR OLDVINT+2
	MOV	AX,2510H
	INT	21H
	MOV	ES,ES:PSP
	MOV	AH,49H
	INT	21H
	MOV	AX,4C00H
	INT	21H

;detect Trident

INIT:	MOV	DX,03C4H	;select switch register
	MOV	AL,0BH
	OUT	DX,AL
	INC	DX
	IN	AL,DX
	MOV	BL,AL		;save in BL
	DEC	DX
	MOV	AX,0BH		;switch to old mode
	OUT	DX,AX
	INC	DX
	IN	AL,DX		;now to new mode
	DEC	DX
	MOV	AL,0EH		;new mode control 2
	OUT	DX,AL
	INC	DX
	IN	AL,DX
	MOV	BH,AL		;save in BH
	XOR	AL,AL
	OUT	DX,AL
	IN	AL,DX		;read probed value
	AND	AL,0FH
	MOV	AH,AL		;save in AH
	MOV	AL,BH		;restore new mode control 2
	XOR	AL,2		;with inverted bit 1
	OUT	DX,AL
	DEC	DX
	MOV	AL,0BH		;select switch register
	OUT	DX,AL
	INC	DX
	MOV	AL,BL		;restore it
	OUT	DX,AL
	CMP	AH,2		;compare probed value
	JNZ	NOT89		;not a trident chip
	MOV	AH,9
	MOV	DX,OFFSET MSG2	;'Trident detected' msg
	INT	21H

;plug in the new video interrupt routine

	MOV	DX,OFFSET VINT
	MOV	AX,2510H
	INT	21H
	MOV	AX,3100H
	MOV	DX,50
	INT	21H

;no Trident chip detected

NOT89:	MOV	AH,9
	MOV	DX,OFFSET MSG3
	INT	21H
	MOV	AX,4C01H
	INT	21H

CODE	ENDS

	END	START
